Package org.apache.bcel.classfile

# Class ModuleOpens

java.lang.Object
org.apache.bcel.classfile.ModuleOpens

All Implemented Interfaces:
  `Cloneable`, `Node`

public final class ModuleOpens extends Object implements Cloneable, Node
This class represents an entry in the opens table of the Module attribute. Each entry describes a package which the parent module opens.

Since:
  6.4.0
See Also:
  - `Module`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `accept(Visitor v)`
  Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class.
  `ModuleOpens`
  `copy()`
  `void`
  `dump(DataOutputStream file)`
  Dump table entry to file stream in binary format.
  `int`
  `getOpensFlags()`
  Gets the flags for this ModuleOpens.
  `String`
  `getPackageName(ConstantPool constantPool)`
  Gets the opened package name.
  `String[]`
  `getToModuleNames(ConstantPool constantPool)`
  Gets an array of module names for this ModuleOpens.
  `String`
  `toString()`
  `String`
  `toString(ConstantPool constantPool)`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### accept

    public void accept(Visitor v)
    Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
    Specified by:
      `accept` in interface `Node`
    Parameters:
      `v` - Visitor object

  - ### copy

    public ModuleOpens copy()
    Returns:
      deep copy of this object

  - ### dump

    public void dump(DataOutputStream file) throws IOException
    Dump table entry to file stream in binary format.
    Parameters:
      `file` - Output file stream
    Throws:
      `IOException` - if an I/O Exception occurs in writeShort

  - ### getOpensFlags

    public int getOpensFlags()
    Gets the flags for this ModuleOpens.
    Returns:
      the opensFlags
    Since:
      6.10.0

  - ### getPackageName

    public String getPackageName(ConstantPool constantPool)
    Gets the opened package name.
    Parameters:
      `constantPool` - the constant pool from the ClassFile
    Returns:
      the opened package name
    Since:
      6.10.0

  - ### getToModuleNames

    public String[] getToModuleNames(ConstantPool constantPool)
    Gets an array of module names for this ModuleOpens.
    Parameters:
      `constantPool` - Array of constants usually obtained from the ClassFile object
    Returns:
      array of module names following 'opens to'
    Since:
      6.10.0

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`
    Returns:
      String representation

  - ### toString

    public String toString(ConstantPool constantPool)
    Returns:
      Resolved string representation